#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <avr/pgmspace.h>
#include "uart.h"
#include "i2cmaster.h"


#define XTAL_CPU        7372800
#define UART_BAUD_RATE     38400
#define PCF8574  0x40


void delay_ms(uint16_t ms)
{
	uint16_t zaehler;
	
	while (ms) 
	{
		zaehler = XTAL_CPU / 5000;
		while (zaehler) 
		{
			asm volatile ("nop");
			zaehler--;
		}
		ms--;
	}
}

int main(void)
{
    DDRD &= ~(1<<PD2);
    PORTD |= (1<<PD2);
	MCUCR |= (1<<ISC01);
	GICR |= (1<<INT0);
    uart_init( UART_BAUD_SELECT(UART_BAUD_RATE,XTAL_CPU) ); 

    sei();
    
    uart_puts("Programm Started:\n");
    i2c_init();  
    uart_puts("init I2C\n");

	for(;;){   
	}
}

SIGNAL(SIG_INTERRUPT0) {
	cli();
	
	unsigned int i;
	unsigned char ret=0;
	ret = i2c_start(PCF8574+I2C_READ);

    if ( ret ) {
        i2c_stop();
        uart_puts("i2c not ready\n")
    }else {
        ret = i2c_readNak();
       		
		for (i=0; i<8; i++){
			if (ret & (1<<7-i))
				uart_putc ('1');
			else
				uart_putc ('0');
		}
    }  
	
	sei();	
}
